/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... znaky
*/
#include<iostream>
#include<cctype> // znaky
using namespace std;

/* Pokud je znak male pismeno, funkce ho prevede na velke pismeno, jinak ho necha beze zmeny. */
char naVelke(char znak)
{
	if (znak >= 'a' && znak <= 'z')
		znak = znak - 'a' + 'A'; //		znak -= ('a' - 'A');
	return znak;
}

/* Pokud je znak velke pismeno, funkce ho prevede na male pismeno, jinak ho necha beze zmeny. */
char naMale(char znak)
{
	if (znak >= 'A' && znak <= 'Z')
		znak = znak - 'A' + 'a'; //		znak += ('a' - 'A');
	return znak;
}

/* Funkce vypise na konzoli informace o znaku a jeho ASCII kod. */
void info(char znak)
{
	cout << "Znak " << znak;
	if (znak >= 'a' && znak <= 'z')
		cout << " je male pismeno.";
	else if (znak >= 'A' && znak <= 'Z')
		cout << " je velke pismeno.";
	else if (znak >= '0' && znak <= '9')
		cout << " je cislice.";
	else
		cout << " je jiny typ znaku.";
	cout << " Jeho ASCII kod je " << (int)znak << endl;

}

/* Funkce postupne nacte cely radek textu a zmeni v nem mala pismena na velka. Vysledek vypise na konzoli. */
void celyRadek()
{
	cout << "Zadej radek textu:" << endl;
	char znak;
	do
	{
		znak = getchar();
		cout << naVelke(znak);
	} while (znak != '\n');
}

/* Funkce vytiskne na konzoli sachovnici. */
void sachovnice()
{
	char bilePolicko = 219;
	char cernePolicko = 176;
	cout << endl;
	for (int i = 0; i < 8; i++)
	{
		for (int j = 0; j < 8; j++)
		{
			if (j % 2 == i % 2)
			{
				cout << bilePolicko << bilePolicko;
			}
			else
			{
				cout << cernePolicko << cernePolicko;
			}
		}
		cout << endl;
	}
	cout << endl;
}



void objemy()
{
	const double pi = 3.14152;
	cout << "Kalkulacka pro vypocet objemu a povrchu teles." << endl;

	char z;
	double V, S, r, v, a;
	do
	{
		if (!cin)
		{
			cin.clear();
			cin.ignore(256, '\n');
		}
		cout << "Pro vypocet objemu a povrchu koule stiskni k" << endl;
		cout << "Pro vypocet objemu a povrchu valce stiskni v" << endl;
		cout << "Pro vypocet objemu a povrchu jehlanu stiskni j" << endl;
		cout << "Pokud chces ukoncit vypocet, stiskni z" << endl;
		cin >> z;

		switch (z)
		{
		case 'k':

			cout << "****** Objem a povrch koule ******" << endl;
			cout << "Zadej polomer koule: ";
			cin >> r;
			V = 4.0 / 3 * pi * pow(r, 3);
			S = 4 * pi * r * r;
			cout << "objem koule je " << V << ", jeji povrch je " << S << endl;
			break;
		case 'v':
			cout << "****** Objem a povrch valce ******" << endl;
			cout << "Zadej polomer podstavy valce: ";
			cin >> r;
			cout << "Zadej vysku valce: ";
			cin >> v;
			V = pi * pow(r, 2) * v;
			S = 2 * pi * r * (r + v);
			cout << "objem jehlanu je " << V << ", jeho povrch je " << S << endl;
			break;
		case 'j':
			cout << "****** Objem a povrch jehlanu ******" << endl;
			cout << "Zadej delku strany podstavy jehlanu: ";
			cin >> a;
			cout << "Zadej vysku jehlanu: ";
			cin >> v;
			V = 1.0 / 3 * v * pow(a, 2);
			S = a * (a + sqrt(4 * pow(v, 2) + pow(a, 2)));
			cout << "objem jehlanu je " << V << ", jeho povrch je " << S << endl;
			break;
		default:
			z = 'z';
			break;
		}
	} while (z != 'z');

}

int main()
{
	cout << "****** Vypis informaci o znaku ******" << endl;
	info('f');
	info('Z');
	info('4');
	info('\n');

	cout << "\n\n****** Mala a velka pismena ******" << endl;
	char znak = naMale('F');
	cout << znak;
	cout << naMale('G') << naMale(' ') << naMale('h') << naMale('1') << naMale('\n');
	cout << naVelke(znak) << naVelke('G') << naVelke(' ') << naVelke('h') << naVelke('1') << naVelke('\n');

	cout << "\n****** Prevod celeho radku textu na velka pismena ******" << endl;
	celyRadek();

	cout << "\n******  Sachovnice ******" << endl;
	sachovnice();

	cout << "\n******  Objemy a povrchy ******" << endl;
	objemy();
	return 0;
}